import { IParameter } from "../Project/ProjectSubmitWork/interface";
export const getCustomTemplateParameterCheckResult = (
  parameter: IParameter,
): {
  error: boolean;
  helperText: string;
} => {
  let error = false;
  let helperText = "";
  // 输出不做校验
  if (parameter.parameterGroup === "out") {
    return {
      error,
      helperText,
    }
  }
  // 表单校验
  if (parameter.required) {
    // 提交任务时不展示
    if (parameter.hidden) {
      if (Array.isArray(parameter.defaultValue)) {
        if (parameter.defaultValue.length === 0) {
          error = true;
          helperText = "该参数为必填，您必须为该参数赋予默认值";
        }
      } else if (parameter.defaultValue === "" || parameter.defaultValue === null || parameter.defaultValue === undefined) {
        error = true;
        helperText = "该参数为必填，您必须为该参数赋予默认值";
      }
    }
  }
  if (error) {
    return {
      error,
      helperText,
    };
  }
  // 有值才做validators旋律校验
  if (parameter.defaultValue) {
    if (Array.isArray(parameter.validators)) {
      if (parameter.validators.length > 0) {
        parameter.validators.forEach((validator) => {
          const reg = new RegExp(validator.regex);
          if (!reg.test(parameter.defaultValue)) {
            error = true;
            helperText = validator.message;
          }
        });
      }
    }
  }
  return {
    error,
    helperText,
  };
};
